{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Graf.TCanvas.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Graf.TCanvas.RawType
import HROOT.Graf.TCanvas.FFI
import HROOT.Graf.TCanvas.Interface
import HROOT.Graf.TCanvas.Cast
import HROOT.Graf.TCanvas.RawType
import HROOT.Graf.TCanvas.Cast
import HROOT.Graf.TCanvas.Interface
import HROOT.Hist.TH1F.RawType
import HROOT.Hist.TH1F.Cast
import HROOT.Hist.TH1F.Interface
import HROOT.Graf.TView.RawType
import HROOT.Graf.TView.Cast
import HROOT.Graf.TView.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Graf.TPad.RawType
import HROOT.Graf.TPad.Cast
import HROOT.Graf.TPad.Interface
import HROOT.Core.TVirtualPad.RawType
import HROOT.Core.TVirtualPad.Cast
import HROOT.Core.TVirtualPad.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAttPad.RawType
import HROOT.Core.TAttPad.Cast
import HROOT.Core.TAttPad.Interface
import HROOT.Core.TQObject.RawType
import HROOT.Core.TQObject.Cast
import HROOT.Core.TQObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITCanvas (TCanvas) where
        toggleEditor = xform0 c_tcanvas_toggleeditor
        toggleEventStatus = xform0 c_tcanvas_toggleeventstatus
        toggleToolBar = xform0 c_tcanvas_toggletoolbar
        toggleToolTips = xform0 c_tcanvas_toggletooltips

instance () => ITPad (TCanvas) where
        drawFrame = xform5 c_tcanvas_drawframe
        getView = xform0 c_tcanvas_getview
        setView0 = xform0 c_tcanvas_setview0
        setView = xform1 c_tcanvas_setview

instance () => ITVirtualPad (TCanvas) where
        cd = xform1 c_tcanvas_cd
        divide_tvirtualpad = xform5 c_tcanvas_divide_tvirtualpad
        modified = xform1 c_tcanvas_modified
        range = xform4 c_tcanvas_range
        setLogx = xform1 c_tcanvas_setlogx
        setLogy = xform1 c_tcanvas_setlogy
        setLogz = xform1 c_tcanvas_setlogz
        update = xform0 c_tcanvas_update

instance () => ITObject (TCanvas) where
        clear = xform1 c_tcanvas_clear
        draw = xform1 c_tcanvas_draw
        findObject = xform1 c_tcanvas_findobject
        getName = xform0 c_tcanvas_getname
        isA = xform0 c_tcanvas_isa
        paint = xform1 c_tcanvas_paint
        printObj = xform1 c_tcanvas_printobj
        saveAs = xform2 c_tcanvas_saveas
        write = xform3 c_tcanvas_write
        write_ = xform0 c_tcanvas_write_

instance () => ITAttLine (TCanvas) where
        getLineColor = xform0 c_tcanvas_getlinecolor
        getLineStyle = xform0 c_tcanvas_getlinestyle
        getLineWidth = xform0 c_tcanvas_getlinewidth
        resetAttLine = xform1 c_tcanvas_resetattline
        setLineAttributes = xform0 c_tcanvas_setlineattributes
        setLineColor = xform1 c_tcanvas_setlinecolor
        setLineStyle = xform1 c_tcanvas_setlinestyle
        setLineWidth = xform1 c_tcanvas_setlinewidth

instance () => ITAttFill (TCanvas) where
        setFillColor = xform1 c_tcanvas_setfillcolor
        setFillStyle = xform1 c_tcanvas_setfillstyle

instance () => ITAttPad (TCanvas) where
        resetAttPad = xform1 c_tcanvas_resetattpad
        setBottomMargin = xform1 c_tcanvas_setbottommargin
        setLeftMargin = xform1 c_tcanvas_setleftmargin
        setRightMargin = xform1 c_tcanvas_setrightmargin
        setTopMargin = xform1 c_tcanvas_settopmargin
        setMargin = xform4 c_tcanvas_setmargin
        setAfile = xform1 c_tcanvas_setafile
        setXfile = xform1 c_tcanvas_setxfile
        setYfile = xform1 c_tcanvas_setyfile
        setAstat = xform1 c_tcanvas_setastat
        setXstat = xform1 c_tcanvas_setxstat
        setYstat = xform1 c_tcanvas_setystat

instance () => ITQObject (TCanvas) where

instance () => IDeletable (TCanvas) where
        delete = xform0 c_tcanvas_delete

newTCanvas ::
             (Castable c1 CString, Castable c0 CString) =>
             c0 -> c1 -> CInt -> CInt -> IO TCanvas
newTCanvas = xform3 c_tcanvas_newtcanvas
